--[[
Gemböbble
Copyright (c) 2010-2011 Carl Ådahl

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.
]]
local LG, LI = love.graphics, love.image

BallShadow = 
{ 	
}

local function generateShadow()
	local shadowData = LI.newImageData(96,96)
	shadowData:mapPixel(function(x,y,r,g,b,a)
		x = x - 47.5
		y = y - 47.5
		local r = math.sqrt((x^2)+(y^2))
		r = math.max(0,r-32) / 16 
		local c = 1 - r
		if c > 0.001 then
			c = math.pow(c,2.5)
		end
		c = c * 0.6
		return 255,255,255,math.max(0,math.min(255,255*c))
	end)

	return LG.newImage(shadowData)
end

-- Generate shadow texture.
local shadow = generateShadow()

function BallShadow.new(ball)
	local s = Actor.new("ballshadow")

	-- Initialize the actor.
	function s.init()
		s.drawPriority = -50
		s.scale = 1
		-- No state needed
	end
	
	function s.draw()
		LG.pushMaterial()
		LG.setBlendMode("alpha")
		LG.setColorMode("modulate")
		local c = 0
		local a = 160
		LG.setColor(c,c,c,a)
		LG.draw(shadow, 
				s.getX(),
				s.getY(),
				0,
				s.scale,
				s.scale,
				shadow:getWidth()/2,
				shadow:getHeight()/2 )		
		LG.popMaterial()
	end
	
	s.init()
	return s	
end

