--[[
Gemböbble
Copyright (c) 2010-2011 Carl Ådahl

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.
]]
BallShine = 
{ 	
}

local shineImageData = love.image.newImageData("img/ballshine.png")
local imgSize = 96
local images = {}

-- Static initialization
for i=1,Ball.colorCount do
	local tempData = love.image.newImageData(imgSize, imgSize)
	tempData:paste(shineImageData, 0, 0, (i-1)*imgSize, 0, imgSize, imgSize)
	images[i] = love.graphics.newImage(tempData)
end

function BallShine.new(ball)
	local s = Actor.new("ballshine")
	local shine = images[ball.color]
	s.setDrawPriority(50)

	function s.draw()
		local lg = love.graphics
		lg.pushMaterial()
		lg.setBlendModeRGB("dst_alpha", "one_minus_src_color")
		lg.setBlendModeAlpha("zero", "one")
		local c = 130
		local a = 255
		lg.setColor(c,c,c,a)
		lg.draw(shine,
				s.getX(),
				s.getY(),
				0,
				1,
				1,
				shine:getWidth()/2,
				shine:getHeight()/2 )		
		lg.popMaterial()
	end

	function s.states.normal()
		s.wait()
	end

	s.enterState("normal")

	return s	
end

