--[[
Gemböbble
Copyright (c) 2010-2011 Carl Ådahl

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.
]]
FlareEffect = {}

local flare = love.graphics.newImage("img/flareeffect.png")

function FlareEffect.new(x,y)

	local s = Actor.new("flareeffect")
	local alpha = 255
	local angle = math.rad(math.random(3600000)/10000)
	
	function s.init()
		s.drawPriority = 2
		s.enterState("fade")
	end

	function s.getX()
		return x
	end

	function s.getY()
		return y
	end

	function s.draw()
		local lg = love.graphics
		local aa = math.lerp(0.5,1.0,alpha/255)
		local scale = (1.1*aa)^2
		lg.pushMaterial()
		lg.setBlendMode("alpha")
		lg.setColor(255,255,255,alpha*0.8)
		lg.draw(flare, x, y, angle, scale, scale, flare:getWidth()/2, flare:getHeight()/2)	
		lg.popMaterial()
	end

	function s.states.fade()
		while s.update() do
			alpha = alpha - s.dt*12
			if alpha <= 0 then
				alpha = 0
				world.remove(s)
			end
		end
	end

	s.init()
	return s
end

